"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const string_decoder_1 = require("string_decoder");
const stream_1 = require("stream");
exports.createReplaceTransform = (transformer) => {
    const decoder = new string_decoder_1.StringDecoder('utf8');
    return new stream_1.Transform({
        transform(chunk, encoding, callback) {
            this.push(transformer(decoder.write(chunk)));
            callback();
        },
        flush(callback) {
            const last = decoder.end();
            last && this.push(transformer(last));
            callback();
        }
    });
};
//# sourceMappingURL=transform.js.map